<%@ page contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>
<!DOCTYPE html>
<html>

<head>
    <link rel="stylesheet" href="./css/style.css">
    <!-- Leaflet CCS file -->
    <link rel="stylesheet" href="https://unpkg.com/leaflet@1.9.3/dist/leaflet.css"
          integrity="sha256-kLaT2GOSpHechhsozzB+flnD+zUyjE2LlfWPgU04xyI="
          crossorigin=""/>


    <!-- <script src="js/sensor-Data-Fetch-Servlet.js"></script> -->

    <script src="js/sensor-Data-WebSocket.js"></script>

    <title>Smart Ocean Dashboard</title>
</head>
<body>

<!-- Top navigation bar -->
<div class="topnav">
    <img src="./css/SFI_SmartOcean_logo.png" alt="Logo" style="float: left">
    <a class="active" href="./index.jsp" style="float: left">Smart Ocean Data Visualisation Dashboard</a>
    <a href="About.html">About</a>
    <a href="Help.html">Help</a>
    <a href="Settings.html">Settings</a>
    <a href="Admin.html">Admin</a>
    <a href="Connection.html">Connection</a>
</div>

<!-- Headline -->
<h1 class="h1">Smart Ocean Dashboard</h1>

<!-- Map -->
<div id="map"></div>

<!-- Leaflet JS file -->
<script src="https://unpkg.com/leaflet@1.9.3/dist/leaflet.js"
        integrity="sha256-WBkoXOwTeyKclOHuWtc+i2uENFpDZ9YPdf5Hf+D7ewM="
        crossorigin=""></script>

<script src="./js/map.js"></script>


<noscript>Your browser does not support Javascript</noscript>

<h2 id="date"></h2>

<h3 style="color: #4c9e71">Analog Sensor</h3>
<table id="AnalogTable">
    <thead>
    <tr>
        <th>Turbidity</th>
    </tr>
    </thead>
    <tbody>
    <!-- data rows will be added dynamically -->
    <tr>
        <td></td>
    </tr>
    </tbody>
</table>
<h3 style="color: #4c9e71">Conductivity Sensor</h3>
<table id="ConductivityTable">
    <thead>
    <tr>
        <th>Temperature</th>
        <th>Conductivity</th>
        <th>Salinity</th>
        <th>Density</th>
        <th>SoundSpeed</th>

    </tr>
    </thead>
    <tbody>
    <!-- data rows will be added dynamically -->
    <tr>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
    </tr>
    </tbody>
</table>

<h3 style="color: #4c9e71">Optode Sensor</h3>
<table id="OptodeTable">
    <thead>
    <tr>
        <th>O2 Concentration</th>
        <th>Air Saturation</th>
        <th>Temperature</th>
    </tr>
    </thead>
    <tbody>
    <!-- data rows will be added dynamically -->
    <tr>
        <td></td>
        <td></td>
        <td></td>
    </tr>
    </tbody>
</table>
<h3 style="color: #4c9e71">Seabird Sensor</h3>
<table id="SeabirdTable">
    <thead>
    <tr>
        <th>Temperature</th>
        <th>Conductivity</th>
        <th>Pressure</th>
        <th>Oxygen</th>
        <th>SoundVelocity</th>

    </tr>
    </thead>
    <tbody>
    <!-- data cells will be updated dynamically -->
    <tr>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
    </tr>
    </tbody>
</table>
<h3 style="color: #4c9e71">Temperature Sensor</h3>
<table id="TemperatureTable">
    <thead>
    <tr>
        <th>Temperature</th>
    </tr>
    </thead>
    <tbody>
    <!-- data rows will be added dynamically -->
    <tr>
        <td></td>
    </tr>
    </tbody>
</table>
<h3 style="color: #4c9e71">Tide Sensor</h3>
<table id="TideTable">
    <thead>
    <tr>
        <th>Temperature</th>
        <th>Pressure</th>
        <th>TidePressure</th>
        <th>TideLevel</th>
    </tr>
    </thead>
    <tbody>
    <tr>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
    </tr>
    </tbody>
</table>
<h3 style="color: #4c9e71">Doppler Current Profiler Sensor</h3>
<table id="DopplerTable">
    <thead>
    <tr>
        <th>NoisePeakLevelB1</th>
        <th>NoisePeakLevelB2</th>
        <th>NoisePeakLevelB3</th>
        <th>NoisePeakLevelB4</th>
        <th>NoiseAverageLevelB1</th>
        <th>NoiseAverageLevelB2</th>
        <th>NoiseAverageLevelB3</th>
        <th>NoiseAverageLevelB4</th>
        <th>RecordState</th>
        <th>PingCount</th>
    </tr>
    </thead>
    <tbody>
    <tr>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
    </tr>
    </tbody>
</table>

<!-- Bottom bar -->
<div class="navbar">
    <a href="./index.jsp" class="active">Smart Ocean Data Visualisation Dashboard</a>
</div>


</body>
</html>