package Database;

import SensorClass.*;
import com.mongodb.*;
import com.mongodb.client.*;
import org.bson.Document;

import java.util.ArrayList;


public class DAO {
    private final static String CONNECT_URI = "mongodb+srv://paalbrugger:rm8BOOvammMLBoyn@smartoceansensordata.z0sj2xt.mongodb.net/?retryWrites=true&w=majority";
    private static MongoDatabase database = null;

    public static void StoreSensorData(ArrayList<AbstractSensorData> sensorData, String collectionName) {

        try (MongoClient mongoClient = MongoClients.create(CONNECT_URI)) {
            database = mongoClient.getDatabase("SensorDataDemo");
            MongoCollection<Document> collection = database.getCollection(collectionName);
            int id = generateId(collectionName);

            Document analogSensor = new Document("_id", id)
                    .append("SensorID", sensorData.get(0).getId())
                    .append("Time", sensorData.get(0).getTime())
                    .append("Turbidity", ((AnalogSensor) sensorData.get(0)).getTurbidity());

            Document conductivitySensor = new Document("_id", id + 1)
                    .append("SensorID", sensorData.get(1).getId())
                    .append("Time", sensorData.get(1).getTime())
                    .append("Temperature", ((ConductivitySensor) sensorData.get(1)).getTemperature())
                    .append("Conductivity", ((ConductivitySensor) sensorData.get(1)).getConductivity())
                    .append("Salinity", ((ConductivitySensor) sensorData.get(1)).getSalinity())
                    .append("Density", ((ConductivitySensor) sensorData.get(1)).getDensity())
                    .append("Soundspeed", ((ConductivitySensor) sensorData.get(1)).getSoundspeed());

            Document dopplerSensor = new Document("_id", id + 2)
                    .append("SensorID", sensorData.get(2).getId())
                    .append("Time", sensorData.get(2).getTime())
                    .append("NoisePeakLevelB1", ((DopplerCurrentProfilerSensor) sensorData.get(2)).getNoisePeakLevelB1())
                    .append("NoisePeakLevelB2", ((DopplerCurrentProfilerSensor) sensorData.get(2)).getNoisePeakLevelB2())
                    .append("NoisePeakLevelB3", ((DopplerCurrentProfilerSensor) sensorData.get(2)).getNoisePeakLevelB3())
                    .append("NoisePeakLevelB4", ((DopplerCurrentProfilerSensor) sensorData.get(2)).getNoisePeakLevelB4())
                    .append("NoiseAverageLevelB1", ((DopplerCurrentProfilerSensor) sensorData.get(2)).getNoiseAverageLevelB1())
                    .append("NoiseAverageLevelB2", ((DopplerCurrentProfilerSensor) sensorData.get(2)).getNoiseAverageLevelB2())
                    .append("NoiseAverageLevelB3", ((DopplerCurrentProfilerSensor) sensorData.get(2)).getNoiseAverageLevelB3())
                    .append("NoiseAverageLevelB4", ((DopplerCurrentProfilerSensor) sensorData.get(2)).getNoiseAverageLevelB4())
                    .append("RecordState", ((DopplerCurrentProfilerSensor) sensorData.get(2)).getRecordState())
                    .append("PingCount", ((DopplerCurrentProfilerSensor) sensorData.get(2)).getPingCount());

            Document optodeSensor = new Document("_id", id + 3)
                    .append("SensorID", sensorData.get(3).getId())
                    .append("Time", sensorData.get(3).getTime())
                    .append("O2Concentration", ((OxygenOptodeSensor) sensorData.get(3)).getO2Concentration())
                    .append("AirSaturation", ((OxygenOptodeSensor) sensorData.get(3)).getAirSaturation())
                    .append("Temperature", ((OxygenOptodeSensor) sensorData.get(3)).getTemperature());

            Document seaBirdSensor = new Document("_id", id + 4)
                    .append("SensorID", sensorData.get(4).getId())
                    .append("Time", sensorData.get(4).getTime())
                    .append("Temperature", ((SeaBirdSensor) sensorData.get(4)).getTemperature())
                    .append("Conductivity", ((SeaBirdSensor) sensorData.get(4)).getConductivity())
                    .append("Pressure", ((SeaBirdSensor) sensorData.get(4)).getPressure())
                    .append("Oxygen", ((SeaBirdSensor) sensorData.get(4)).getOxygen())
                    .append("Sound", ((SeaBirdSensor) sensorData.get(4)).getSoundVelocity());


            Document temperatureSensor = new Document("_id", id + 5)
                    .append("SensorID", sensorData.get(5).getId())
                    .append("Time", sensorData.get(5).getTime())
                    .append("Temperature", ((TemperatureSensor) sensorData.get(5)).getTemperature());

            Document tideSensor = new Document("_id", id + 6)
                    .append("SensorID", sensorData.get(6).getId())
                    .append("Time", sensorData.get(6).getTime())
                    .append("Temperature", ((TideSensor) sensorData.get(6)).getTemperature())
                    .append("Pressure", ((TideSensor) sensorData.get(6)).getPressure())
                    .append("TidePressure", ((TideSensor) sensorData.get(6)).getTidePressure())
                    .append("TideLevel", ((TideSensor) sensorData.get(6)).getTideLevel());


            collection.insertOne(analogSensor);
            collection.insertOne(conductivitySensor);
            collection.insertOne(dopplerSensor);
            collection.insertOne(optodeSensor);
            collection.insertOne(seaBirdSensor);
            collection.insertOne(temperatureSensor);
            collection.insertOne(tideSensor);


            System.out.println("Data stored successfully");

        } catch (MongoWriteException e) {
            System.out.println("Something went wrong while trying to store data, probably duplicate keys");
        }
    }

    public static ArrayList<AbstractSensorData> RetrieveRecentSensorData(String collectionName) {
        try (MongoClient mongoClient = MongoClients.create(CONNECT_URI)) {
            database = mongoClient.getDatabase("SensorDataDemo");
            MongoCollection<Document> collection = database.getCollection(collectionName);

            ArrayList<Document> latestEntries = new ArrayList<>();
            MongoCursor<Document> cursor = collection.find().sort(new Document("_id", -1)).limit(7).iterator();

            try {
                while (cursor.hasNext()) {
                    Document entry = cursor.next();
                    latestEntries.add(entry);
                }
            } finally {
                cursor.close();
            }

            AnalogSensor as = new AnalogSensor(latestEntries.get(6).getString("SensorID"), latestEntries.get(6).getString("Time"), latestEntries.get(6).getDouble("Turbidity"));
            ConductivitySensor cs = new ConductivitySensor(latestEntries.get(5).getString("SensorID"), latestEntries.get(5).getString("Time"), latestEntries.get(5).getDouble("Conductivity"), latestEntries.get(5).getDouble("Temperature"), latestEntries.get(5).getDouble("Salinity"), latestEntries.get(5).getDouble("Density"), latestEntries.get(5).getDouble("Soundspeed"));
            DopplerCurrentProfilerSensor dp = new DopplerCurrentProfilerSensor(latestEntries.get(4).getString("SensorID"), latestEntries.get(4).getString("Time"), latestEntries.get(4).getDouble("NoisePeakLevelB1"), latestEntries.get(4).getDouble("NoisePeakLevelB2"), latestEntries.get(4).getDouble("NoisePeakLevelB3"), latestEntries.get(4).getDouble("NoisePeakLevelB4"), latestEntries.get(4).getDouble("NoiseAverageLevelB1"), latestEntries.get(4).getDouble("NoiseAverageLevelB2"), latestEntries.get(4).getDouble("NoiseAverageLevelB3"), latestEntries.get(4).getDouble("NoiseAverageLevelB4"), latestEntries.get(4).getDouble("RecordState"), latestEntries.get(4).getDouble("PingCount"));
            OxygenOptodeSensor op = new OxygenOptodeSensor(latestEntries.get(3).getString("SensorID"), latestEntries.get(3).getString("Time"), latestEntries.get(3).getDouble("O2Concentration"), latestEntries.get(3).getDouble("AirSaturation"), latestEntries.get(3).getDouble("Temperature"));
            SeaBirdSensor sp = new SeaBirdSensor(latestEntries.get(2).getString("SensorID"), latestEntries.get(2).getString("Time"), latestEntries.get(2).getDouble("Temperature"), latestEntries.get(2).getDouble("Conductivity"), latestEntries.get(2).getDouble("Pressure"), latestEntries.get(2).getDouble("Oxygen"), latestEntries.get(2).getDouble("Sound"));
            TemperatureSensor tp = new TemperatureSensor(latestEntries.get(1).getString("SensorID"), latestEntries.get(1).getString("Time"), latestEntries.get(1).getDouble("Temperature"));
            TideSensor ts = new TideSensor(latestEntries.get(0).getString("SensorID"), latestEntries.get(0).getString("Time"), latestEntries.get(0).getDouble("Pressure"), latestEntries.get(0).getDouble("Temperature"), latestEntries.get(0).getDouble("TidePressure"), latestEntries.get(0).getDouble("TideLevel"));


            ArrayList<AbstractSensorData> latestEntriesJava = new ArrayList<>();
            latestEntriesJava.add(as);
            latestEntriesJava.add(cs);
            latestEntriesJava.add(dp);
            latestEntriesJava.add(op);
            latestEntriesJava.add(sp);
            latestEntriesJava.add(tp);
            latestEntriesJava.add(ts);

            return latestEntriesJava;

        }


    }

    private static int generateId(String collectionName) {
        try (MongoClient mongoClient = MongoClients.create(CONNECT_URI)) {
            database = mongoClient.getDatabase("SensorDataDemo");
            MongoCollection<Document> collection = database.getCollection(collectionName);

            FindIterable<Document> result = collection.find().sort(new Document("_id", -1)).limit(1);
            MongoCursor<Document> cursor = result.iterator();

            int nextId;

            if (cursor.hasNext()) {
                nextId = cursor.next().getInteger("_id") + 1;
            } else {
                nextId = 1;
            }
            return nextId;
        }
    }


}

