package SensorClass;

public class ConductivitySensor extends AbstractSensorData{
    private Double conductivity;

    private Double temperature;

    private Double salinity;
    private Double density;
    private Double soundspeed;

    public ConductivitySensor(String id, String time, Double conductivity, Double temperature, Double salinity, Double density, Double soundspeed) {
        super(id, "Conductivity Sensor", time);
        this.temperature = temperature;
        this.conductivity = conductivity;
        this.salinity = salinity;
        this.density = density;
        this.soundspeed = soundspeed;
    }

    public Double getTemperature() {
        return temperature;
    }

    public void setTemperature(Double temperature) {
        this.temperature = temperature;
    }

    public Double getConductivity() {
        return conductivity;
    }

    public void setConductivity(Double conductivity) {
        this.conductivity = conductivity;
    }

    public Double getSalinity() {
        return salinity;
    }

    public void setSalinity(Double salinity) {
        this.salinity = salinity;
    }

    public Double getDensity() {
        return density;
    }

    public void setDensity(Double density) {
        this.density = density;
    }

    public Double getSoundspeed() {
        return soundspeed;
    }

    public void setSoundspeed(Double soundspeed) {
        this.soundspeed = soundspeed;
    }

    @Override
    public String toString() {
        return "ConductivitySensor{" +
                "temperature=" + temperature +
                ", conductivity=" + conductivity +
                ", salinity=" + salinity +
                ", density=" + density +
                ", soundspeed=" + soundspeed +
                '}';
    }
}
