setInterval(function () {
    fetch('/updateData-servlet')
        .then(response => response.json())
        .then(data => {
            var date = document.getElementById("date");
            date.innerText = "SensorData Date:   " + data[0].time

            var tableAn = document.getElementById("AnalogTable");
            var rowAn = tableAn.tBodies[0].rows[0];
            rowAn.cells[0].innerText = data[0].turbidity + " FTU";

            var tableCs = document.getElementById("ConductivityTable");
            var rowCs = tableCs.tBodies[0].rows[0];
            rowCs.cells[0].innerText = data[1].temperature + " °C";
            rowCs.cells[1].innerText = data[1].conductivity + " S/m";
            rowCs.cells[2].innerText = data[1].salinity + " PSU";
            rowCs.cells[3].innerText = data[1].density + " kg/m^3";
            rowCs.cells[4].innerText = data[1].soundspeed + " m/s";

            var tableDp = document.getElementById("DopplerTable");
            var rowDp = tableDp.tBodies[0].rows[0];
            rowDp.cells[0].innerText = data[2].noisePeakLevelB1 + " dB";
            rowDp.cells[1].innerText = data[2].noisePeakLevelB2 + " dB";
            rowDp.cells[2].innerText = data[2].noisePeakLevelB3 + " dB";
            rowDp.cells[3].innerText = data[2].noisePeakLevelB4 + " dB";
            rowDp.cells[4].innerText = data[2].noiseAverageLevelB1 + " dB";
            rowDp.cells[5].innerText = data[2].noiseAverageLevelB2 + " dB";
            rowDp.cells[6].innerText = data[2].noiseAverageLevelB3 + " dB";
            rowDp.cells[7].innerText = data[2].noiseAverageLevelB4 + " dB";
            rowDp.cells[8].innerText = data[2].recordState;
            rowDp.cells[9].innerText = data[2].pingCount;


            var tableOp = document.getElementById("OptodeTable");
            var rowOp = tableOp.tBodies[0].rows[0];
            rowOp.cells[0].innerText = data[3].o2Concentration + " uM";
            rowOp.cells[1].innerText = data[3].airSaturation + " %";
            rowOp.cells[2].innerText = data[3].temperature + " °C";

            var tableSb = document.getElementById("SeabirdTable");
            var rowSb = tableSb.tBodies[0].rows[0];
            if(isRowEmpty(rowSb)){
                    rowSb.cells[0].innerText = data[4].temperature + "°C";
                    rowSb.cells[1].innerText = data[4].conductivity + " S/m";
                    rowSb.cells[2].innerText = data[4].pressure + " kPa";
                    rowSb.cells[3].innerText = data[4].oxygen + " mg/l";
                    rowSb.cells[4].innerText = data[4].soundVelocity + " %";
            }else {
                    rowSb.cells[0].innerText = "N/A"
                    rowSb.cells[1].innerText = "N/A"
                    rowSb.cells[2].innerText = "N/A"
                    rowSb.cells[3].innerText = "N/A"
                    rowSb.cells[4].innerText = "N/A"
            }
            var tableTp = document.getElementById("TemperatureTable");
            var rowTp = tableTp.tBodies[0].rows[0];
            rowTp.cells[0].innerText = data[5].temperature + " °C";

            var tableTd = document.getElementById("TideTable");
            var rowTd = tableTd.tBodies[0].rows[0];
            rowTd.cells[0].innerText = data[6].temperature + " °C";
            rowTd.cells[1].innerText = data[6].pressure + " kPa";
            rowTd.cells[2].innerText = data[6].tidePressure + " kPa";
            rowTd.cells[3].innerText = data[6].tideLevel + " m";

            console.log("reload");
        })

}, 10000); // 10 seconds in milliseconds


function isRowEmpty(row) {
    // Loop through each cell in the row
    for (var i= 0; i < row.cells.length; i++) {
        // Check if the cell contains any content
        if (parseInt(row.cells[i].innerText) !== 0) {
            // If the cell contains content, return false
            return false;
        }
    }
    // If all cells are empty, return true
    return true;
}
function updateTable(data){
    var date = document.getElementById("date");
    date.innerText = "SensorData Date:   " + data[0].time

    var tableAn = document.getElementById("AnalogTable");
    var rowAn = tableAn.tBodies[0].rows[0];
    rowAn.cells[0].innerText = data[0].turbidity + " FTU";

    var tableCs = document.getElementById("ConductivityTable");
    var rowCs = tableCs.tBodies[0].rows[0];
    rowCs.cells[0].innerText = data[1].temperature + " °C";
    rowCs.cells[1].innerText = data[1].conductivity + " S/m";
    rowCs.cells[2].innerText = data[1].salinity + " PSU";
    rowCs.cells[3].innerText = data[1].density + " kg/m^3";
    rowCs.cells[4].innerText = data[1].soundspeed + " m/s";

    var tableDp = document.getElementById("DopplerTable");
    var rowDp = tableDp.tBodies[0].rows[0];
    rowDp.cells[0].innerText = data[2].noisePeakLevelB1 + " dB";
    rowDp.cells[1].innerText = data[2].noisePeakLevelB2 + " dB";
    rowDp.cells[2].innerText = data[2].noisePeakLevelB3 + " dB";
    rowDp.cells[3].innerText = data[2].noisePeakLevelB4 + " dB";
    rowDp.cells[4].innerText = data[2].noiseAverageLevelB1 + " dB";
    rowDp.cells[5].innerText = data[2].noiseAverageLevelB2 + " dB";
    rowDp.cells[6].innerText = data[2].noiseAverageLevelB3 + " dB";
    rowDp.cells[7].innerText = data[2].noiseAverageLevelB4 + " dB";
    rowDp.cells[8].innerText = data[2].recordState;
    rowDp.cells[9].innerText = data[2].pingCount;


    var tableOp = document.getElementById("OptodeTable");
    var rowOp = tableOp.tBodies[0].rows[0];
    rowOp.cells[0].innerText = data[3].o2Concentration + " uM";
    rowOp.cells[1].innerText = data[3].airSaturation + " %";
    rowOp.cells[2].innerText = data[3].temperature + " °C";

    var tableSb = document.getElementById("SeabirdTable");
    var rowSb = tableSb.tBodies[0].rows[0];
    if(isRowEmpty(rowSb)){
        rowSb.cells[0].innerText = data[4].temperature + "°C";
        rowSb.cells[1].innerText = data[4].conductivity + " S/m";
        rowSb.cells[2].innerText = data[4].pressure + " kPa";
        rowSb.cells[3].innerText = data[4].oxygen + " mg/l";
        rowSb.cells[4].innerText = data[4].soundVelocity + " %";
    }else {
        rowSb.cells[0].innerText = "N/A"
        rowSb.cells[1].innerText = "N/A"
        rowSb.cells[2].innerText = "N/A"
        rowSb.cells[3].innerText = "N/A"
        rowSb.cells[4].innerText = "N/A"
    }
    var tableTp = document.getElementById("TemperatureTable");
    var rowTp = tableTp.tBodies[0].rows[0];
    rowTp.cells[0].innerText = data[5].temperature + " °C";

    var tableTd = document.getElementById("TideTable");
    var rowTd = tableTd.tBodies[0].rows[0];
    rowTd.cells[0].innerText = data[6].temperature + " °C";
    rowTd.cells[1].innerText = data[6].pressure + " kPa";
    rowTd.cells[2].innerText = data[6].tidePressure + " kPa";
    rowTd.cells[3].innerText = data[6].tideLevel + " m";
}


