var socket = new WebSocket("ws://localhost:8081");
var rigName = document.getElementById("rigName");
rigName.innerText = "Austevoll - Nord";
var selectedSensor = "Austevoll - Nord";


// Set up a callback for when the WebSocket connection is established
socket.addEventListener("open", () => {
    console.log("WebSocket connected");

    rigName.innerText = "Austevoll - Nord";
    austevollNordMarker.setIcon(redIcon);

    // Send a message to the server
    socket.send("Austevoll - Nord");


});

austevollNordMarker.addEventListener("click", function () {
    rigName.innerText = "Austevoll - Nord";
    socket.send("Austevoll - Nord");
    selectedSensor = "Austevoll - Nord";
    austevollNordMarker.setIcon(redIcon);
    austevollMarker.setIcon(blueIcon);
    austevollSorMarker.setIcon(blueIcon);

});

austevollMarker.addEventListener("click", function () {
    rigName.innerText = "Austevoll";
    socket.send("Austevoll");
    selectedSensor = "Austevoll";
    austevollMarker.setIcon(redIcon);
    austevollNordMarker.setIcon(blueIcon);
    austevollSorMarker.setIcon(blueIcon);


});

austevollSorMarker.addEventListener("click", function () {
    rigName.innerText = "Austevoll - Sør";
    socket.send("Austevoll - Sor");
    selectedSensor = "Austevoll - Sor";
    austevollSorMarker.setIcon(redIcon);
    austevollNordMarker.setIcon(blueIcon);
    austevollMarker.setIcon(blueIcon);


});

// When a message is received from the server
socket.addEventListener("message", (event) => {
    console.log("Received message: " + event.data);
    const sensorData = JSON.parse(event.data);

    if (sensorData[0].id === "AN100-14257" && selectedSensor === "Austevoll - Nord") {
        updateTables(sensorData);
    } else if (sensorData[0].id === "AN100-0" && selectedSensor === "Austevoll") {
        updateTables(sensorData);
    } else if (sensorData[0].id === "AN100-0" && selectedSensor === "Austevoll - Sor") {
        updateTables(sensorData);
    }
});

// Set up a callback for when the WebSocket connection is closed
socket.addEventListener("close", () => {
    console.log("WebSocket closed");
    rigName.innerText = "";
});


// Set up a callback for when an error occurs
socket.addEventListener("error", (error) => {
    console.error("WebSocket error: " + error.message);
});


function updateTables(data) {
    var date = document.getElementById("date");
    date.innerText = "Date:   " + data[0].time.substring(0, 19).replace("T", " ");

    var tableAn = document.getElementById("AnalogTable");
    var rowAn = tableAn.tBodies[0].rows[0];
    rowAn.cells[0].innerText = data[0].turbidity + " FTU";

    var tableCs = document.getElementById("ConductivityTable");
    var rowCs = tableCs.tBodies[0].rows[0];
    if (!isObjectPropertiesZero(data[1])) {
        rowCs.cells[0].innerText = data[1].temperature + " °C";
        rowCs.cells[1].innerText = data[1].conductivity + " S/m";
        rowCs.cells[2].innerText = data[1].salinity + " PSU";
        rowCs.cells[3].innerText = data[1].density + " kg/m^3";
        rowCs.cells[4].innerText = data[1].soundspeed + " m/s";
    } else {
        rowCs.cells[0].innerText = "N/A";
        rowCs.cells[1].innerText = "N/A";
        rowCs.cells[2].innerText = "N/A";
        rowCs.cells[3].innerText = "N/A";
        rowCs.cells[4].innerText = "N/A";
    }
    var tableDp = document.getElementById("DopplerTable");
    var rowDp = tableDp.tBodies[0].rows[0];
    if (!isObjectPropertiesZero(data[2])) {
        rowDp.cells[0].innerText = data[2].noisePeakLevelB1 + " dB";
        rowDp.cells[1].innerText = data[2].noisePeakLevelB2 + " dB";
        rowDp.cells[2].innerText = data[2].noisePeakLevelB3 + " dB";
        rowDp.cells[3].innerText = data[2].noisePeakLevelB4 + " dB";
        rowDp.cells[4].innerText = data[2].noiseAverageLevelB1 + " dB";
        rowDp.cells[5].innerText = data[2].noiseAverageLevelB2 + " dB";
        rowDp.cells[6].innerText = data[2].noiseAverageLevelB3 + " dB";
        rowDp.cells[7].innerText = data[2].noiseAverageLevelB4 + " dB";
        rowDp.cells[8].innerText = data[2].recordState;
        rowDp.cells[9].innerText = data[2].pingCount;
    } else {
        rowDp.cells[0].innerText = "N/A"
        rowDp.cells[1].innerText = "N/A"
        rowDp.cells[2].innerText = "N/A"
        rowDp.cells[3].innerText = "N/A"
        rowDp.cells[4].innerText = "N/A"
        rowDp.cells[5].innerText = "N/A"
        rowDp.cells[6].innerText = "N/A"
        rowDp.cells[7].innerText = "N/A"
        rowDp.cells[8].innerText = "N/A"
        rowDp.cells[9].innerText = "N/A"
    }

    var tableOp = document.getElementById("OptodeTable");
    var rowOp = tableOp.tBodies[0].rows[0];
    if (!isObjectPropertiesZero(data[3])) {
        rowOp.cells[0].innerText = data[3].o2Concentration + " uM";
        rowOp.cells[1].innerText = data[3].airSaturation + " %";
        rowOp.cells[2].innerText = data[3].temperature + " °C";
    }else{
        rowOp.cells[0].innerText = "N/A";
        rowOp.cells[1].innerText = "N/A";
        rowOp.cells[2].innerText = "N/A";
    }

    var tableSb = document.getElementById("SeabirdTable");
    var rowSb = tableSb.tBodies[0].rows[0];
    if (!isObjectPropertiesZero(data[4])) {
        rowSb.cells[0].innerText = data[4].temperature + " °C";
        rowSb.cells[1].innerText = data[4].conductivity + " S/m";
        rowSb.cells[2].innerText = data[4].pressure + " kPa";
        rowSb.cells[3].innerText = data[4].oxygen + " mg/l";
        rowSb.cells[4].innerText = data[4].soundVelocity + " %";
    } else {
        rowSb.cells[0].innerText = "N/A"
        rowSb.cells[1].innerText = "N/A"
        rowSb.cells[2].innerText = "N/A"
        rowSb.cells[3].innerText = "N/A"
        rowSb.cells[4].innerText = "N/A"
    }

    var tableTp = document.getElementById("TemperatureTable");
    var rowTp = tableTp.tBodies[0].rows[0];
    rowTp.cells[0].innerText = data[5].temperature + " °C";

    var tableTd = document.getElementById("TideTable");
    var rowTd = tableTd.tBodies[0].rows[0];
    if (!isObjectPropertiesZero(data[6])) {
        rowTd.cells[0].innerText = data[6].temperature + " °C";
        rowTd.cells[1].innerText = data[6].pressure + " kPa";
        rowTd.cells[2].innerText = data[6].tidePressure + " kPa";
        rowTd.cells[3].innerText = data[6].tideLevel + " m";
    } else{
        rowTd.cells[0].innerText = "N/A";
        rowTd.cells[1].innerText = "N/A";
        rowTd.cells[2].innerText = "N/A";
        rowTd.cells[3].innerText = "N/A";
    }
}


function isObjectPropertiesZero(obj) {
    for (var prop in obj) {
        if (typeof obj[prop] === "number" && obj[prop] !== 0) {
            return false;
        }
    }
    return true;
}


